/*
 * Include Python API
 */
#include "python2.2/Python.h"

/*
 * Include cracklib API
 */
#include "crack.h"

/*
 * Simple wrapper for cracklib's FascistCheck function
 */
PyObject *pycrack_FascistCheck(PyObject *self, PyObject *args, PyObject *kwargs) {

    char *pw = "None";
    char *dictpath = "None";
    char *Fascist_check_return = NULL;
    
    static char *argnames[] = {"pw", "dictpath", NULL};
    
    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss", argnames, &pw, &dictpath)) {
        return NULL;
    }
    
    Fascist_check_return = (char *)FascistCheck(pw,dictpath);
    
    return Py_BuildValue("s", Fascist_check_return);
}

/*
 * Method mapping table
 */
static PyMethodDef pycrackmethods[] = {
    {"FascistCheck", pycrack_FascistCheck, METH_VARARGS | METH_KEYWORDS, "Check a password (pw) using cracklib against dictionary file at (dictpath)"}, 
    {NULL, NULL, 0, NULL}
};

/* 
 * Module initialisation function
 */
void initpycrack(void) {
    (void)Py_InitModule("pycrack", pycrackmethods);
}
